package cz.moneta.test.regression.backoffice.ufooperations.jenkinstests;

import cz.moneta.test.dsl.Harness;
import cz.moneta.test.dsl.ufo.operations.search.SearchBy;
import cz.moneta.test.dsl.util.credentials.Keys;
import cz.moneta.test.dsl.util.task.ufo.operations.OperationsTasks;
import cz.moneta.test.harness.annotations.Environment;
import cz.moneta.test.harness.annotations.JiraTestCase;
import cz.moneta.test.harness.annotations.TestCase;
import cz.moneta.test.harness.annotations.TestScenario;
import cz.moneta.test.harness.support.auth.Credentials;
import cz.moneta.test.harness.support.auth.Key;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeAll;

import static cz.moneta.test.dsl.ufo.operations.ufoOperations.TRA740_S001_CreateNewTransferPaymentOrderPage.ID_PAYMENT_ORDER_KEY;
import static cz.moneta.test.dsl.util.task.ufo.cb.CommercialTasks.JIRA_COMMENT_STORE_KEY;

@TestScenario
public class CreatePaymentOrderInTheClientDetail {

    private String cif;

    @BeforeAll
    protected void setUp(Harness harness) {
        cif = harness.getConfig("ufo.operations.cif");
    }

    @TestCase(name = "Create Payment Order In The Client Detail", environments = {Environment.TST1, Environment.PPE})
    @JiraTestCase(id = "BOC-T8469")
    public void createPaymentOrderInTheClientDetail(Harness harness, @Key(Keys.ufo.banka.banker) Credentials credentials) {
        OperationsTasks operationsTasksTasks = harness.tasks().ufo().operations();

        harness.withUfo()
                .openLoginPage()
                .then(operationsTasksTasks.login().withCredentialsAndSelectFirstOM(credentials))
                .fillSearchInput(cif)
                .searchBy(SearchBy.CIF)
                .onClientDetailsPage()
                .clickAccountList()
                .clickTransactions()
                .clickTransactionOrder()
                .clickBackOfficeZaklad()
                .selectOrderType("Reklamace")
                .fillAmount("100")
                .fillVariableSymbol("1234567890")
                .fillSpecificallySymbol("987654321")
                .fillMessage("automat - test")
                .clickSend()
                .saveTaskIDPaymentOrder()
                .assertStatusBarContent("Transakce byla úspěšně založena pod ID:");
    }

    @AfterEach
    protected void teardown(Harness harness) {
        harness.store(JIRA_COMMENT_STORE_KEY,
                "\nUFO Session ID: " + harness.get("reports.tmfj.execution.commentufosessionid", true) +
                        "\nID Transakce: " + harness.get(ID_PAYMENT_ORDER_KEY, true));
    }

}

